clear;close all;
N=[10,50,100,500];

%Aufgabe I
disp('Testaufgabe I')
a=1.5;
t0=0;
y0=exsol1(t0);

for i=1:length(N)
    [h1,t1,y1]=expeuler('fun1',t0,y0,N(i),a);[ye]=exsol1(t1);e1=abs(y1-ye);
    [h2,t2,y2]=modeuler('fun1',t0,y0,N(i),a);[ye]=exsol1(t2);e2=abs(y2-ye);
    [h3,t3,y3]=rk4('fun1',t0,y0,N(i),a);[ye]=exsol1(t3);e3=abs(y3-ye);
    
    disp('ZEITGITTER t');
    disp(num2str(t1(1:N(1)/5:N(1)+1),'  %11.3e'));
    disp(['EXAKTE UND APPROXIMIERTE LOESUNGEN (Expliziter Euler) ZU N=', num2str(N(i))]);
    disp(num2str(ye(1:N(i)/5:N(i)+1),'  %11.3e'));
    disp(num2str(y1(1:N(i)/5:N(i)+1),'  %11.3e'));
    disp(['FEHLER e ZU N=', num2str(N(i))]);
    disp(num2str(e1(1:N(i)/5:N(i)+1),'  %11.3e'));
    
    
    figure(i);
    title(['approximierte Lsg der Aufgabe I, N=',num2str(N(i))]);
    subplot(2,1,1);
    plot(t1,y1,'-b');hold on;
    plot(t2,y2,'-g');
    plot(t3,y3,'-k');
    plot(t3,ye,'r');
    axis tight; box on; grid;
    hleg1 = legend('explEuler','modEuler','rk4','exakt');
    set(hleg1,'fontsize',6)
    %subplot(3,1,2);
    %plot(t1,e1,'-b');hold on;
    %plot(t2,e2,'-g');
    %plot(t3,e3,'-k');
    %axis tight; box on; grid;
    %title('Fehler');
    subplot(2,1,2);
    semilogy(t1,e1,'-b');hold on;
    semilogy(t2,e2,'-g');
    semilogy(t3,e3,'-k');
    axis tight; box on; grid;
    title('Fehler logarithmisch');
    disp(' ');
end


%Aufgabe II)
clear h1 h2 h3 t1 t2 t3 y1 y2 y3 e1 e2 e3
disp('Testaufgabe II')
a=2;
t0=0;
y0=exsol2(t0);

for i=1:length(N)
    [h1,t1,y1]=expeuler('fun2',t0,y0,N(i),a);[ye]=exsol2(t1);e1=abs(y1-ye);
    [h2,t2,y2]=modeuler('fun2',t0,y0,N(i),a);[ye]=exsol2(t2);e2=abs(y2-ye);
    [h3,t3,y3]=rk4('fun2',t0,y0,N(i),a);[ye]=exsol2(t3);e3=abs(y3-ye);
    
    disp('ZEITGITTER t');
    disp(num2str(t1(1:N(1)/5:N(1)+1),'  %11.3e'));
    disp(['EXAKTE UND APPROXIMIERTE LOESUNGEN y(1) (Expliziter Euler) ZU N=', num2str(N(i))]);
    disp(num2str(ye(1:N(i)/5:N(i)+1),'  %11.3e'));
    disp(num2str(y1(1:N(i)/5:N(i)+1),'  %11.3e'));
    disp(['FEHLER e ZU N=', num2str(N(i))]);
    disp(num2str(e1(1:N(i)/5:N(i)+1),'  %11.3e'));
    
    
    figure(i+4);
    %title(['approx. 1. Lsg der Aufgabe II, N=',num2str(N(i))]);
    subplot(2,2,1);
    plot(t1,y1(1,:),'-b');hold on;
    plot(t2,y2(1,:),'-g');
    plot(t3,y3(1,:),'-k');
    plot(t3,ye(1,:),'r');
    axis tight; box on; grid;
    title(['approximierte 1. Lsg der Aufgabe II, N=',num2str(N(i))]);
    hleg1 = legend('explEuler','modEuler','rk4','exakt');
    set(hleg1,'fontsize',6)
    set(hleg1,'Location','SouthWest')

    subplot(2,2,2);
    plot(t1,y1(2,:),'-b');hold on;
    plot(t2,y2(2,:),'-g');
    plot(t3,y3(2,:),'-k');
    plot(t3,ye(2,:),'r');
    axis tight; box on; grid;
   
    title(['approx. 2. Lsg der Aufgabe II, N=',num2str(N(i))]);
    %hleg1 = legend('explEuler','modEuler','rk4','exakt');
    
    
%     subplot(3,2,3);
%     plot(t1,e1(1,:),'-b');hold on;
%     plot(t2,e2(1,:),'-g');
%     plot(t3,e3(1,:),'-k');
%     axis tight; box on; grid;
%     title('Fehler');
%     
%     subplot(3,2,4);
%     plot(t1,e1(2,:),'-b');hold on;
%     plot(t2,e2(2,:),'-g');
%     plot(t3,e3(2,:),'-k');
%     axis tight; box on; grid;
%     title('Fehler');
    
    subplot(2,2,3);
    semilogy(t1,e1(1,:),'-b');hold on;
    semilogy(t2,e2(1,:),'-g');
    semilogy(t3,e3(1,:),'-k');
    axis tight; box on; grid;
    title('Fehler logarithmisch');
    
    subplot(2,2,4);
    semilogy(t1,e1(2,:),'-b');hold on;
    semilogy(t2,e2(2,:),'-g');
    semilogy(t3,e3(2,:),'-k');
    axis tight; box on; grid;
    title('Fehler logarithmisch');
    disp(' ');
end